/******************** (C) COPYRIGHT 2012 e-Design Co.,Ltd. *********************
 File Name : HDW_Config.c
 Version   : DS201 Ver 3.0                                       Author : bure
*******************************************************************************/
#include "string.h"
#include "HDW_Config.h"
#include "Process.h"
#include "Menu.h"
#include "DFU_Func.h"
#include "USB_bot.h"
#include "USB_desc.h"
//#include "msd.h"
#include "Ext_Flash.h"
/*******************************************************************************
* Set_System: System clock initializtion
*******************************************************************************/
void Set_System(void)
{
  RCC_DeInit();
  RCC_HSEConfig(RCC_HSE_ON);
  if(RCC_WaitForHSEStartUp() == SUCCESS)
  {
    FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable);
    FLASH_SetLatency(FLASH_Latency_2);    //Flash 2 wait state
    RCC_HCLKConfig(RCC_SYSCLK_Div1);      //HCLK = SYSCLK
    RCC_PCLK2Config(RCC_HCLK_Div1);       //PCLK2 = HCLK
    RCC_PCLK1Config(RCC_HCLK_Div2);       //PCLK1 = HCLK/2
    RCC_ADCCLKConfig(RCC_PCLK2_Div4);     //ADCCLK = PCLK2/4 = 18MHz
    RCC_PLLConfig(RCC_PLLSource_HSE_Div1, RCC_PLLMul_9);  //PLLCLK = 72 MHz
    RCC_PLLCmd(ENABLE);
    while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET){}
    RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);
    while(RCC_GetSYSCLKSource()!=0x08){}
  }
  RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1, ENABLE);

  RCC_APB2PeriphClockCmd(
    RCC_APB2Periph_ADC1  | RCC_APB2Periph_ADC2  | RCC_APB2Periph_GPIOA |
    RCC_APB2Periph_GPIOB | RCC_APB2Periph_GPIOC | RCC_APB2Periph_GPIOD |
    RCC_APB2Periph_GPIOE | RCC_APB2Periph_AFIO  | RCC_APB2Periph_TIM1, ENABLE);

  RCC_APB1PeriphClockCmd(
    RCC_APB1Periph_TIM2 | RCC_APB1Periph_TIM3 | RCC_APB1Periph_TIM4 |
    RCC_APB1Periph_SPI2, ENABLE);

  RCC_USBCLKConfig(RCC_USBCLKSource_PLLCLK_1Div5);     //USBCLK = 48MHz
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_USB, ENABLE);  //Enable USB clock

}
/*******************************************************************************
* NVIC_Configuration:  interrupt seting  initializtion
*******************************************************************************/
void NVIC_Configuration(void)
{
  NVIC_InitTypeDef NVIC_InitStructure;
  NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x4000);

  NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);

  NVIC_InitStructure.NVIC_IRQChannel = USB_LP_CAN_RX0_IRQChannel;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);

  NVIC_InitStructure.NVIC_IRQChannel = USB_HP_CAN_TX_IRQChannel;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
  // enabling TIM1 interrupt
  NVIC_InitStructure.NVIC_IRQChannel=TIM1_CC_IRQChannel;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
  // enabling TIM3 interrupt
  NVIC_InitStructure.NVIC_IRQChannel=TIM3_IRQChannel;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
  // enabling DMA interrupt
  NVIC_InitStructure.NVIC_IRQChannel=DMA1_Channel2_IRQChannel;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
}

/*******************************************************************************
* GPIO_Config: GPIO port initializtion
*******************************************************************************/
void GPIO_Config(void)
{
  GPIOA_CRL = 0x88888080;  /* GPIOA Bit0-7 ״̬
                |||||||+----- Nib0  Ain   ģ
                ||||||+------ Nib1  NC    
                |||||+------- Nib2  Vbat  ģ
                ||||+-------- Nib3  NC    
                |||+--------- Nib4  KP    
                ||+---------- Nib5  KL    
                |+----------- Nib6  KU    
                +------------ Nib7  KR    */
  GPIOA_CRH = 0x8884488B;  /* GPIOA Bit8-15 ״̬
                |||||||+----- Nib8  MCO   
                ||||||+------ Nib9  NC    
                |||||+------- Nib10 NC    
                ||||+-------- Nib11 D-    
                |||+--------- Nib12 D+    
                ||+---------- Nib13 TMS   
                |+----------- Nib14 TCK   
                +------------ Nib15 TDI   */
  GPIOA_ODR = 0x0FFFF;

  GPIOB_CRL = 0x88888411;  /* GPIOB Bit0-7 ״̬
                |||||||+----- Nib0  A     
                ||||||+------ Nib1  D     
                |||||+------- Nib2  BT1   
                ||||+-------- Nib3  TDO   
                |||+--------- Nib4  TRST  
                ||+---------- Nib5  NC    
                |+----------- Nib6  NC    
                +------------ Nib7  NC    */
  GPIOB_CRH = 0xBBB1B488;  /* GPIOB Bit8-15 ״̬
                |||||||+----- Nib8  NC    
                ||||||+------ Nib9  NC    
                |||||+------- Nib10 Vusb  
                ||||+-------- Nib11 V0    
                |||+--------- Nib12 SDCS  
                ||+---------- Nib13 SCK   
                |+----------- Nib14 MISO  
                +------------ Nib15 MOSI  */
  GPIOB_ODR = 0x0FFFF;

  GPIOC_CRL = 0x84118881;  /* GPIOB Bit0-7 ״̬
                |||||||+----- Nib0  nCLS  
                ||||||+------ Nib1  NC    
                |||||+------- Nib2  NC    
                ||||+-------- Nib3  NC    
                |||+--------- Nib4  C     
                ||+---------- Nib5  B     
                |+----------- Nib6  NC    
                +------------ Nib7  NC    */
  GPIOC_CRH = 0x88888884;  /* GPIOB Bit8-15 ״̬
                |||||||+----- Nib8  NC    
                ||||||+------ Nib9  NC    
                |||||+------- Nib10 NC    
                ||||+-------- Nib11 NC    
                |||+--------- Nib12 NC    
                ||+---------- Nib13 NC    
                |+----------- Nib14 NC    
                +------------ Nib15 NC    */
  GPIOC_ODR = 0x0FFFF;

  GPIOD_CRL = 0x38338838;  /* GPIOB Bit0-7 ״̬
                |||||||+----- Nib0  NC    
                ||||||+------ Nib1  RS    
                |||||+------- Nib2  NC    
                ||||+-------- Nib3  NC    
                |||+--------- Nib4  nRD   
                ||+---------- Nib5  nWR   
                |+----------- Nib6  NC    
                +------------ Nib7  nCS   */
  GPIOD_CRH = 0x888B8884;  /* GPIOB Bit8-15 ״̬
                |||||||+----- Nib8  NC    
                ||||||+------ Nib9  KD    
                |||||+------- Nib10 SDDT  
                ||||+-------- Nib11 KM    
                |||+--------- Nib12 Fout  
                ||+---------- Nib13 NC    
                |+----------- Nib14 NC    
                +------------ Nib15 NC    */
  GPIOD_ODR = 0x0FF7F;

  GPIOE_CRL = 0x33333333;   //Bit0-7  LCD_DB0-7 
  GPIOE_CRH = 0x33333333;   //Bit8-15 LCD_DB8-15

  AFIO_MAPR = 0x00001200;  /* AFIOӳĴ Bit0-31 ״̬
                ||||||++----- Ϊλֵ
                |||||+------- Bit9   TIM2_CH3_CH4 ӳ PB10,PB11
                ||||+-------- Bit12  TIM4_CH1     ӳ PD12
                ++++--------- Ϊλֵ */
}

/*******************************************************************************
*  : Timer_configuration    ˵ : ϵͳʱʼ
*******************************************************************************/
void Tim_Config(void)
{
//---------------TIM1ڶʱADC-------------------
  TIM1_PSC = 72-1;
  TIM1_ARR = 1000-1;
  TIM1_CCR1= 500;
  TIM1_CR1 = 0x0094;/*0000 0000 1001 0100
                      |||| |||| |||| |||+---CEN=0ֹ
                      |||| |||| |||| ||+----UDIS=0UEV
                      |||| |||| |||| |+-----URS=1ֻмжϻDMA
                      |||| |||| |||| +------OPM=0ڷ¼ʱֹͣ
                      |||| |||| |||+--------DIR=1¼
                      |||| |||| |++---------CMS=00ѡضģʽ
                      |||| |||| +-----------ARPE=1TIM1_ARRĴװ뻺
                      |||| ||++-------------CKD=00,CK_INTƵΪ1
                      ++++-++---------------*/
  TIM1_RCR = 0x0000;/*0000 0000 0000 0001
                      |||| |||| ++++ ++++---ڱضģʽ£PWMڵĿ+1
                      ++++-++++-------------*/
  TIM1_CCER =0x0001;/*0000 0000 0000 0001
                      |||| |||| |||| |||+---CC1E=1OC1źӦ
                      |||| |||| |||| ||+----CC1P=0OC1ߵƽЧ
                      |||| |||| |||| |+-----CC1NE=0OC1Nֹ
                      |||| |||| |||| +------CC1NP=0OC1NߵƽЧ
                      ++++-++++-++++--------CC2CC3CC4Ϊλֵ*/
  TIM1_CCMR1=0x0078;/*0000 0000 0111 1100
                      |||| |||| |||| ||++---CC1S=00CC1ͨΪ
                      |||| |||| |||| |+-----OC1FE=1Ƚ1 ʹܣ
                      |||| |||| |||| +------OC1PE=1Ƚ1Ԥװʹ
                      |||| |||| |+++--------0C1M=111PWMģʽ2
                      |||| |||| +-----------OC1CE=0OC1REF ETRFӰ
                      ++++-++++-------------CC2ͨΪλֵ*/
  TIM1_BDTR =0x8000;/*1000 0000 0000 0000
                      |+++-++++-++++-++++---λֲ
                      +---------------------MOE=0ʹ*/
  TIM1_DIER =0x4200;/*0100 0011 0000 0000  DMAжʹܼĴ
                       |     ||        +----CC1IE=0/Ƚ1ж
                       |     |+-------------UDE=1µDMA
                       |     +--------------CC1DE=1/Ƚ1DMA
                       +--------------------TDE=1DMA*/
  TIM1_CR1 |=0x0001;//CEN=1ʹTIMER1

//-----------------TIM2_CH4PWMYͨƫƵѹֵ-------------------
  TIM2_PSC = 0;
  TIM2_ARR = 4096;              //72MHz/3840=17.58KHz
  TIM2_CCR4= 1024;
  TIM2_CR1 = 0x0084;/*0000 0000 1000 0100
                      |||| |||| |||| |||+---CEN=0ֹ
                      |||| |||| |||| ||+----UDIS=0UEV
                      |||| |||| |||| |+-----URS=1ֻмжϻDMA
                      |||| |||| |||| +------OPM=0ڷ¼ʱֹͣ
                      |||| |||| |||+--------DIR=0ϼ
                      |||| |||| |++---------CMS=00ѡضģʽ
                      |||| |||| +-----------ARPE=1TIM2_ARRĴװ뻺
                      |||| ||++-------------CKD=00,CK_INTƵΪ1
                      ++++-++---------------*/
  TIM2_CCER =0x3000;/*0011 0000 0000 0000
                      |||| ++++-++++-++++---CC1CC2CC3Ϊλֵ
                      |||+------------------CC4E=1OC4źӦ
                      ||+-------------------CC4P=1OC4͵ƽЧ
                      |+--------------------CC4NE=0OC4Nֹ
                      +---------------------CC4NP=0OC4NߵƽЧ*/
  TIM2_CCMR2=0x7C00;/*0111 1100 0000 0000
                      |||| |||| ++++-++++---CC3ͨΪλֵ
                      |||| ||++-------------CC4S=00CC4ͨΪ
                      |||| |+---------------OC4FE=1Ƚ4 ʹܣ
                      |||| +----------------OC4PE=1Ƚ4Ԥװʹ
                      |+++------------------0C4M=111PWMģʽ2
                      +---------------------OC4CE=0OC4REF ETRFӰ*/
  TIM2_CR1 |=0x0001;//CEN=1ʹTIMER2

//-----------------TIM3ϵͳʱ-------------------
  TIM3_PSC  =9;  //9
  TIM3_ARR  =7199;  //1mS =PSC+1ARR+1/72MHz/2uS
  TIM3_CCR1 =3600; //ȣռձȣ50%
  TIM3_CR1 = 0x0084;/*0000 0000 1000 0100
                      |||| |||| |||| |||+---CEN=0ֹ
                      |||| |||| |||| ||+----UDIS=0UEV
                      |||| |||| |||| |+-----URS=1ֻмжϻDMA
                      |||| |||| |||| +------OPM=0ڷ¼ʱֹͣ
                      |||| |||| |||+--------DIR=0ϼ
                      |||| |||| |++---------CMS=00ѡضģʽ
                      |||| |||| +-----------ARPE=1TIM3_ARRĴװ뻺
                      |||| ||++-------------CKD=00,CK_INTƵΪ1
                      ++++-++---------------*/
  TIM3_DIER =0x0002;/*0000 0000 0000 0010  DMAжʹܼĴ
                             |         +----CC1IE=1/Ƚ1ж
                             +--------------CC1DE=1/Ƚ1DMA*/
  TIM3_CR1 |=0x0001;//CEN=1ʹTIMER3

//------------------TIM4_CH1ѡƵʵı׼----------------------
  TIM4_PSC = 7;
  TIM4_ARR  =  FARR[List[FREQ_OUT].Val];
  TIM4_CCR1 = (FARR[List[FREQ_OUT].Val]+1)/2;
  TIM4_CR1 = 0x0084;/*0000 0000 1000 0100
                      |||| |||| |||| |||+---CEN=0ֹ
                      |||| |||| |||| ||+----UDIS=0UEV
                      |||| |||| |||| |+-----URS=1ֻмжϻDMA
                      |||| |||| |||| +------OPM=0ڷ¼ʱֹͣ
                      |||| |||| |||+--------DIR=0ϼ
                      |||| |||| |++---------CMS=00ѡضģʽ
                      |||| |||| +-----------ARPE=1TIM3_ARRĴװ뻺
                      |||| ||++-------------CKD=00,CK_INTƵΪ1
                      ++++-++---------------*/
  TIM4_CCER =0x0001;/*0000 0000 0000 0001
                      |||| |||| |||| |||+---CC1E=1OC1źӦ
                      |||| |||| |||| ||+----CC1P=0OC1ߵƽЧ
                      |||| |||| |||| |+-----CC1NE=0OC1Nֹ
                      |||| |||| |||| +------CC1NP=0OC1NߵƽЧ
                      ++++-++++-++++--------CC2CC3CC4Ϊλֵ*/
  TIM4_CCMR1=0x0078;/*0000 0000 0111 1100
                      |||| |||| |||| ||++---CC1S=00CC1ͨΪ
                      |||| |||| |||| |+-----OC1FE=1Ƚ1 ʹܣ
                      |||| |||| |||| +------OC1PE=1Ƚ1Ԥװʹ
                      |||| |||| |+++--------0C1M=111PWMģʽ2
                      |||| |||| +-----------OC1CE=0OC1REF ETRFӰ
                      ++++-++++-------------CC2ͨΪλֵ*/
  TIM4_CR1 |=0x0001;//CEN=1ʹTIMER4
}
/*******************************************************************************
* SPI_Config: SPI  port initializtion
*******************************************************************************/
void SPI_Config(void)
{
  SPI_InitTypeDef   SPI_InitStructure;

  
  SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
  SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
  SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
  SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;
  SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;
  SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
  SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_4;
  SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
  SPI_InitStructure.SPI_CRCPolynomial = 7;
  SPI_Init(SPI2, &SPI_InitStructure);  // SPI2 Config
  SPI_Cmd(SPI2, ENABLE);               // SPI2 enable

}
/*******************************************************************************
* DMA_configuration: DMA channel initializtion
*******************************************************************************/
void DMA_Configuration(void)
{
  DMA_ISR = 0x00000000;/*DMAж״̬ĴͨIFCRӦλ
              |||||||+---GIF1 =0ͨ1ûTEHTTC¼ȫжϱ־
              |||||||+---TCIF1=0ͨ1ûжϱ־
              |||||||+---HTIF1=0ͨ1û봫жϱ־
              |||||||+---TEIF1=0ͨ1ûжϱ־
              ||||||+----ͨ2жϱ־
              ||||++-----ͨ3жϱ־
              ||||++-----ͨ4жϱ־
              |||+-------ͨ5жϱ־
              ||+--------ͨ6жϱ־
              ||+--------ͨ7жϱ־
              +----------*/
  DMA_IFCR= 0x00000000;/*DMAжϱ־Ĵû
              |||||||+---CGIF1 =1ͨ1TEHTTC¼ȫжϱ־
              |||||||+---CTCIF1=1ͨ1Ĵжϱ־
              |||||||+---CHTIF1=1ͨ1İ봫жϱ־
              |||||||+---CTEIF1=1ͨ1Ĵжϱ־
              ||||||+----ͨ2жϱ־
              ||||++-----ͨ3жϱ־
              ||||++-----ͨ4жϱ־
              |||+-------ͨ5жϱ־
              ||+--------ͨ6жϱ־
              ||+--------ͨ7жϱ־
              +----------*/
  DMA1_CCR1=  0x00003580;/*0011 0101 1000 0000
               ||||       |||| |||| |||| |||+--EN = 0ͨرգ1ͨ
               ||||       |||| |||| |||| ||+---TCIE=0ж
               ||||       |||| |||| |||| |+----HTIE=0ֹ봫ж
               ||||       |||| |||| |||| +-----TEIE=0ֹж
               ||||       |||| |||| |||+-------DIR =0ݴ䷽򣨴
               ||||       |||| |||| ||+--------CIRC=0ִѭ
               ||||       |||| |||| |+---------PINC=0ִַģʽ
               ||||       |||| |||| +----------MINC=1ִд洢ַģʽ
               ||||       |||| ||++------------PSIZE=0116λݿ
               ||||       |||| ++--------------MSIZE=0116λ洢ݿ
               ||||       ||++-----------------PL=11ͨȼ
               ||||       |+-------------------MEM2MEM=0Ǵ洢洢ģʽ
               ++++-------+--------------------*/

  DMA1_CNDTR1 = 0x00001000;          // DMAͨ1Ĵ(1024*2 Bytes)
  DMA1_CPAR1  = ADC1_DR_ADDR;        // DMAͨ1ݼĴַ
  DMA1_CMAR1  = (u32)&Sampl[1];      // DMAͨ1ԴĿĴ洢ַ
  DMA1_CCR1  |= 0x00000001;          // EN = 1DMAͨ1
}
/*******************************************************************************
* ADC_configuration: ADC initializtion
*******************************************************************************/
void ADC_Configuration(void)
{
  ADC2_CR1 =0x00000000;
  ADC1_CR1 =0x00000000;/*
              ||||||++---AWDCH[4:0]ģ⿴Źͨѡλ
              ||||||+----=000EOCAWDJEOCж
              |||||+-----Nib8_SCAN=0ʹɨģʽ
              ||||++-----ָλֵ
              |||+-------DUALMOD=0ģʽ
              ||+--------ͨעͨģ⿴Ź
              ++---------*/
  ADC2_CR2 =0x00100000;
  ADC1_CR2 =0x00100100;/*
              |||||||+---ADON=0رADCת/У׼=1ADCת
              |||||||+---CONT=01תģʽ
              |||||||+---CAL=0=1A/DУʼ׼У׼λӲ
              |||||||+---RSTCAL=0=1ʼУ׼ĴУ׼λӲ
              ||||||+----
              |||||+-----ALIGN=0 & DMA=1ҶʹDMAģʽ
              ||||+------
              |||+-------=0000ͨʹöʱ1CC1¼ת=1110SWSTART
              ||+--------=1ʹⲿźת
              ++---------*/
  ADC2_SQR1=0x00000000;
  ADC1_SQR1=0x00000000;/*ADCмĴ 1
              ||++++++---SQ13-16=00000תе13-16תͨ(5Bits*4)
              ++---------*/
  ADC2_SQR3 =0x00000002;
  ADC1_SQR3 =0x00000000;/*ADCмĴ 3
               ||||||++---SQ1=00000תеĵ1תͨı(0)
               +++++++----SQ2-6=00000תе2-6תͨ(5Bits*5)
               +----------*/
  ADC2_SMPR2=0x00000000;
  ADC1_SMPR2=0x00000000;/*ADCʱĴ 1
               |||||||+---SMP01=001(3Bits)ʹͨ00Ĳʱ 1.5T
               ||||+------SMP04=001(3Bits)ʹͨ04Ĳʱ 7.5T
               |+++++++---SMP11-17=000(3Bits*7)ͨ11-17Ĳʱ 1.5T
               ++---------*/
  ADC1_CR2 |=0x00000001;
  ADC2_CR2 |=0x00000001;       //ADON=1ADC1ADC2
  ADC1_CR2 |=0x00000008;
  while(ADC1_CR2 & 0x00000008);//ʼADC1У׼Ĵ
  ADC2_CR2 |=0x00000008;
  while(ADC2_CR2 & 0x00000008);//ʼADC2У׼Ĵ
  ADC1_CR2 |=0x00000004;
  while(ADC1_CR2 & 0x00000004);//ADC1У׼
  ADC2_CR2 |=0x00000004;
  while(ADC2_CR2 & 0x00000004);//ADC2У׼
}


/******************************** END OF FILE *********************************/
